; The decompression routine itself
DeComp:
	ld   a, (hl)												; b should already be 0
	inc  hl
	cp   %01000000
	jr   nc, DoDeComp
	
	ld   c, a
	or   a
	ret  z														; EOF
	ldir														; Simply dump the data
	jr   DeComp

DoDeComp:
	push af

	and  %00011111
	add  a, 2
	cp   33
	jr   nz, NotMax

	add  a, (hl)
	rl   b
	inc  hl

NotMax:
	ld   c, a													; Here, bc = Length
	pop  af
	push hl
	ld   l, (hl)
	rlca
	rlca
	rlca
	or   %11111000
	ld   h, a

	add  hl, de
	ldir
	pop  hl
	inc  hl
	jr   DeComp
